# The workdir is used in the build system for ISC dhcp, we set it to this
# value to avoid any problems guessing what it might be during installation.
%define workdir work.linux-2.2

# The vendor name to append to the version number
%define vvendor CCux

Distribution:   CCux
Packager:	Stefan Gottwald <gotti@ccux-linux.de>

Summary:	DHCP (Dynamic Host Configuration Protocol) server and relay agent
Name:		dhcp
Version:	3.0.6
Release:	1
License:	ISC
URL:		http://www.isc.org/products/DHCP
Group:		Networking/Servers
Source0:	%{name}-%{version}.tar.gz
Source1:  	dhcpd.conf.sample
Source2:  	dhcpd.init
Source3:  	dhcrelay.init
Source4:  	dhcpd.conf
Source5:  	libdhcp4client.pc
Source6:  	README.ldap
Source7:  	draft-ietf-dhc-ldap-schema-01.txt
Source8:  	dhcpd-conf-to-ldap
Source9:  	linux.dbus-example
Source10: 	linux
Source11: 	Makefile.dist
Source12: 	dhcp4client.h
Source13: 	libdhcp_control.h

Patch0:   	%{name}-3.0.5-Makefile.patch
Patch1:   	%{name}-3.0.5-warnings.patch
Patch2:   	%{name}-3.0.5-errwarn-message.patch
Patch3:   	%{name}-3.0.5-ldap-configuration.patch
Patch4:   	%{name}-3.0.6-memory.patch
Patch5:   	%{name}-3.0.6-options.patch
Patch6:   	%{name}-3.0.5-release-by-ifup.patch
Patch7:   	%{name}-3.0.5-dhclient-decline-backoff.patch
Patch8:   	%{name}-3.0.5-enable-timeout-functions.patch
Patch9:   	%{name}-3.0.5-inherit-leases.patch
Patch10:  	%{name}-3.0.5-unicast-bootp.patch
Patch11:  	%{name}-3.0.5-fast-timeout.patch
Patch12:  	%{name}-3.0.5-failover-ports.patch
Patch13:  	%{name}-3.0.6-dhclient-usage.patch
Patch14:  	%{name}-3.0.5-default-requested-options.patch
Patch15:  	%{name}-3.0.5-prototypes.patch
Patch16:  	%{name}-3.0.6-manpages.patch
Patch17:  	%{name}-3.0.6-libdhcp4client.patch
Patch18:  	%{name}-3.0.6-xen-checksum.patch
Patch19:  	%{name}-3.0.5-dhclient-anycast.patch
Patch20:  	%{name}-3.0.6-ignore-hyphen-x.patch


BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildRequires:	sed openldap-devel

Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/service
Requires(postun): /sbin/service



%description
DHCP (Dynamic Host Configuration Protocol) is a protocol which allows
individual devices on an IP network to get their own network
configuration information (IP address, subnetmask, broadcast address,
etc.) from a DHCP server. The overall purpose of DHCP is to make it
easier to administer a large network.  The dhcp package includes the
ISC DHCP service and relay agent.

To use DHCP on your network, install a DHCP service (or relay agent),
and on clients run a DHCP client daemon.  The dhcp package provides
the ISC DHCP service and relay agent.

%package -n dhclient
Summary: 	Provides the dhclient ISC DHCP client daemon and dhclient-script
Group: 		System/Base
#Requires: initscripts >= 6.75
#Obsoletes: dhcpcd <= 3.0.16-2
#Provides: dhcpcd = 3.0.16-3

%description -n dhclient
DHCP (Dynamic Host Configuration Protocol) is a protocol which allows
individual devices on an IP network to get their own network
configuration information (IP address, subnetmask, broadcast address,
etc.) from a DHCP server. The overall purpose of DHCP is to make it
easier to administer a large network.

To use DHCP on your network, install a DHCP service (or relay agent),
and on clients run a DHCP client daemon.  The dhclient package
provides the ISC DHCP client daemon.

%package devel
Summary: 	Development headers and libraries for interfacing to the DHCP server
Group: 		Development/Libraries
Requires: 	dhcp = %{version}-%{release}

%description devel
Header files and API documentation for using the ISC DHCP libraries.

%package static
Summary: 	Static archives of libdhcpctl and libomapi
Group: 		Development/Libraries
Requires: 	dhcp-devel = %{version}-%{release}, openldap-devel

%description static
The dhcp-static package contains the static archive for
libdhcpctl and libomapi.

%package -n libdhcp4client
Summary: 	ISC DHCP IPv4 client in a library for invocation from other programs
Group: 		Development/Libraries

%description -n libdhcp4client
The Internet Software Consortium (ISC) Dynamic Host Configuration Protocol
(DHCP) Internet Protocol version 4 (IPv4) client software in a library
suitable for linkage with and invocation by other programs.

%package -n libdhcp4client-devel
Summary: 	Header files for development with the ISC DHCP IPv4 client library
Group: 		Development/Libraries
Requires: 	libdhcp4client = %{version}-%{release}
Requires: 	openldap-devel pkgconfig

%description -n libdhcp4client-devel
Header files for development with the Internet Software Consortium (ISC)
Dynamic Host Configuration Protocol (DHCP) Internet Protocol version 4 (IPv4)
client library.

%package -n libdhcp4client-static
Summary: 	Static archive for libdhcp4client
Group: 		Development/Libraries
Requires: 	libdhcp4client-devel = %{version}-%{release}

%description -n libdhcp4client-static
The libdhcp4client-static package contains the static archive for
libdhcp4client.

%post
# This adds the proper /etc/rc*.d links for the script
/sbin/chkconfig --add dhcpd
/sbin/chkconfig --add dhcrelay

%preun
if [ $1 = 0 ]; then
    /sbin/service dhcpd stop >/dev/null 2>&1 || :
    /sbin/service dhcrelay stop >/dev/null 2>&1 || :
    /sbin/chkconfig --del dhcpd
    /sbin/chkconfig --del dhcrelay
fi

%postun
if [ "$1" -ge "1" ]; then
    /sbin/service dhcpd condrestart >/dev/null 2>&1 || :
    /sbin/service dhcrelay condrestart >/dev/null 2>&1 || :
fi

%post -n libdhcp4client -p /sbin/ldconfig

%postun -n libdhcp4client -p /sbin/ldconfig



%prep
%setup -q

# Add vendor to the version number
%{__sed} -e 's|V%{version}|V%{version}-%{vvendor}|g' includes/version.h > includes/version.h.new
%{__mv} includes/version.h.new includes/version.h

# Use $(MAKE) and $(CC) in the Makefiles
%patch0 -p1 -b .Makefile

# Fix up anything that fails -Wall -Werror
%patch1 -p1 -b .warnings

# Replace the standard ISC warning message about requesting help with an
# explanation that this is a patched build of ISC DHCP and bugs should be
# reported through bugzilla.redhat.com
%patch2 -p1 -b .message

# Add support for dhcpd.conf data in LDAP
%patch3 -p1 -b .ldap

# Fix memory alignment and initialization problems in common/packet.c
# Fix buffer overflow in minires library
# Init struct sock_prog in common/lpf.c to NULL
%patch4 -p1 -b .memory

# Add more dhclient options (-I, -B, -H, -F, -T, -V, and -R)
%patch5 -p1 -b .options

# Handle releasing interfaces requested by /sbin/ifup
# pid file is assumed to be /var/run/dhclient-$interface.pid
%patch6 -p1 -b .release

# If we receive a DHCP offer in dhclient and it's DECLINEd in dhclient-script,
# backoff for an amount of time before trying again
%patch7 -p1 -b .decline

# Enable cancel_all_timeouts() and relinquish_timeouts() regardless of
# the DEBUG_MEMORY_LEAKAGE_ON_EXIT macro
%patch8 -p1 -b .etf

# Inherit active leases
%patch9 -p1 -b .inherit

# Support unicast BOOTP for IBM pSeries systems (and maybe others)
%patch10 -p1 -b .unicast

# Fast timeout for dhclient
%patch11 -p1 -b .fast

# Use the following IANA-registered failover ports:
# dhcp-failover 647/tcp
# dhcp-failover 647/udp
# dhcp-failover 847/tcp
# dhcp-failover 847/udp
%patch12 -p1 -b .failover

# Update the usage screen for dhclient(8) indicating new options
# Use printf() rather than log_info() to display the information
# Also, return EXIT_FAILURE when the usage() screen is displayed (stop parsing)
%patch13 -p1 -b .usage

# Add NIS domain, NIS servers, and NTP servers to the list of default
# requested DHCP options
%patch14 -p1 -b .dho

# Add missing prototypes to take care of gcc warnings
# in dst/dst_api.c: add b64_pton() and b64_ntop()
# in includes/minires/minires.h: remove macro for b64_pton
# in minires/res_mkupdate.c: add b64_pton() and dn_comp()
# in minires/res_comp.c: add ns_name_uncompress(), ns_name_compress(), and
#                        ns_name_skip()
# in minires/res_init.c: add res_randomid()
%patch15 -p1 -b .prototypes

# Man page updates explaining new features added from the above patches.
# Normally these man page changes would be included in the feature patch,
# however, man page changes generate more hunk failures when applying only
# a select set of patches.  Instead, the man page changes are grouped
# together in one patch so changes can be made to just those more easily
# and not affect the code changes in the other patches.  It's actually
# pretty common to update or alter these man pages independent of the code
# changes.
%patch16 -p1 -b .manpages

# Add the libdhcp4client target (library version of dhclient)
%patch17 -p1 -b .libdhcp4client

# Handle Xen partial UDP checksums
%patch18 -p1 -b .xen

# Add anycast support to dhclient (for OLPC)
%patch19 -p1 -b .anycast

# Ignore the old extended new option info command line switch (-x)
%patch20 -p1 -b .enoi

# Copy in documentation and example scripts for LDAP patch to dhcpd
%{__install} -p -m 0644 %SOURCE6 .
%{__install} -p -m 0644 %SOURCE7 doc
%{__install} -p -m 0755 %SOURCE8 contrib

# Copy in example dhclient script for use with D-BUS (requires extended
# new option info patch too)
%{__install} -p -m 0755 %SOURCE9 client/scripts

# Copy in the Fedora/RHEL dhclient script
%{__install} -p -m 0755 %SOURCE10 client/scripts

# Copy in the libdhcp4client headers and Makefile.dist
%{__mkdir} -p libdhcp4client
%{__install} -p -m 0644 %SOURCE11 libdhcp4client
%{__install} -p -m 0644 %SOURCE12 libdhcp4client
%{__install} -p -m 0644 %SOURCE13 libdhcp4client

# Ensure we don't pick up Perl as a dependency from the scripts and modules
# in the contrib directory (we copy this to /usr/share/doc in the final
# package).
%{__cp} -a contrib __fedora_contrib
%{__chmod} -x __fedora_contrib/3.0b1-lease-convert
%{__chmod} -x __fedora_contrib/dhcpd-conf-to-ldap
%{__mv} __fedora_contrib/ms2isc/Registry.pm __fedora_contrib/ms2isc/Registry.perlmodule

# We want UNIX-style line endings
%{__sed} -i -e 's/\r//' __fedora_contrib/ms2isc/readme.txt
%{__sed} -i -e 's/\r//' __fedora_contrib/ms2isc/Registry.perlmodule
%{__sed} -i -e 's/\r//' __fedora_contrib/ms2isc/ms2isc.pl


###############OLD
#cat <<-END >> includes/site.h
##define _PATH_DHCPD_CONF "/etc/dhcp/dhcpd.conf"
##define _PATH_DHCPD_PID "/var/run/dhcp/dhcpd.pid"
##define _PATH_DHCPD_DB "/var/lib/dhcp/dhcpd.leases"
##define _PATH_DHCLIENT_DB "/var/lib/dhcp/dhclient.leases"
##define DHCPD_LOG_FACILITY LOG_LOCAL1
##END
#cat <<-END > site.conf
#CC = gcc
#LFLAGS = ${LDFLAGS}
#LIBDIR = %_libdir
#INCDIR = %_includedir
#ETC = /etc/dhcp
#VARDB = /var/lib/dhcp
#VARRUN = /var/run/dhcp
#ADMMANDIR = %{_mandir}/man8
#FFMANDIR = %{_mandir}/man5
#LIBMANDIR = %{_mandir}/man3
#USRMANDIR = %{_mandir}/man1
#END
#################OLD									    

%build
%{__cp} %SOURCE1 .
%{__cat} <<EOF > site.conf
VARDB=%{_localstatedir}/lib/dhcpd
ADMMANDIR=%{_mandir}/man8
FFMANDIR=%{_mandir}/man5
LIBMANDIR=%{_mandir}/man3
USRMANDIR=%{_mandir}/man1
LIBDIR=%{_libdir}
INCDIR=%{_includedir}
EOF
%{__cat} <<EOF >> includes/site.h
#define _PATH_DHCPD_DB    "%{_localstatedir}/lib/dhcpd/dhcpd.leases"
#define _PATH_DHCLIENT_DB "%{_localstatedir}/lib/dhclient/dhclient.leases"
EOF

# Disable gcc's strict aliasing since ISC code tends to cast a lot.
##
## Use -fvisibility=hidden for libdhcp4client.  The way that library is
## constructed, we need to follow the hide-by-default/expose-what-we-need
## plan for the library API.
#COPTS="-fPIC -Werror -Dlint -fno-strict-aliasing -fvisibility=hidden"
COPTS="-fPIC -Werror -Dlint -fno-strict-aliasing"

# DO NOT use the %%configure macro because this configure script is not autognu
#CC="%{__cc}" ./configure \
#   --copts "$RPM_OPT_FLAGS $COPTS" \
#   --work-dir %{workdir}

%{__sed} 's/@DHCP_VERSION@/%{version}/' < %SOURCE5 > libdhcp4client.pc
#%{__make} %{?_smp_mflags} CC="%{__cc}"


##############OLD
./configure --copts "${CFLAGS}"
make

%install
%{__rm} -rf %{buildroot}
%{__mkdir} -p %{buildroot}%{_sysconfdir}/sysconfig

%{__make} install DESTDIR=%{buildroot}

%{__mkdir} -p %{buildroot}%{_initrddir}
%{__install} -p -m 0755 %SOURCE2 %{buildroot}%{_initrddir}/dhcpd

touch %{buildroot}%{_localstatedir}/lib/dhcpd/dhcpd.leases
%{__mkdir} -p %{buildroot}%{_localstatedir}/lib/dhclient/
%{__cat} <<EOF > %{buildroot}%{_sysconfdir}/sysconfig/dhcpd
# Command line options here
DHCPDARGS=
EOF

%{__install} -p -m 0755 %SOURCE3 %{buildroot}%{_initrddir}/dhcrelay

%{__cat} <<EOF > %{buildroot}%{_sysconfdir}/sysconfig/dhcrelay
# Command line options here
INTERFACES=""
DHCPSERVERS=""
EOF

# Copy sample dhclient.conf file into position
%{__cp} -p client/dhclient.conf dhclient.conf.sample
%{__chmod} 0755 %{buildroot}/sbin/dhclient-script

# Install default (empty) dhcpd.conf:
%{__cp} -fp %SOURCE4 %{buildroot}%{_sysconfdir}

%{__install} -p -m 0644 -D libdhcp4client.pc %{buildroot}%{_libdir}/pkgconfig/libdhcp4client.pc

# Sources files can't be symlinks for debuginfo package generation
find %{workdir} -type l |
while read f; do
    %{__rm} -f linkderef
    %{__cp} $f linkderef
    %{__rm} -f $f
    %{__mv} linkderef $f
done


##################OLD
#rm -rf %{buildroot}
#make install DESTDIR=%{buildroot}
#mkdir -p %{buildroot}%{_sysconfdir}/{dhcp,sysconfig,rc.d/init.d}
#install -m 644 server/dhcpd.conf %{buildroot}/etc/dhcp/dhcpd.conf.sample
#install -m 644 client/dhclient.conf %{buildroot}/etc/dhcp/dhclient.conf.sample
#install -m 755 %{SOURCE1} %{buildroot}%{_sysconfdir}/rc.d/init.d/dhcp
#install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/dhcp
#mkdir -p %{buildroot}/var/{lib,run}/dhcp
#find %{buildroot} -type f \
#-exec /usr/bin/strip --strip-debug '{}' ';' 

%files
%defattr(-,root,root,-)
%doc README README.ldap RELNOTES dhcpd.conf.sample doc/IANA-arp-parameters
%doc doc/IANA-arp-parameters doc/api+protocol doc/*.txt __fedora_contrib
%dir %{_localstatedir}/lib/dhcpd
%verify(not size md5 mtime) %config(noreplace) %{_localstatedir}/lib/dhcpd/dhcpd.leases
%config(noreplace) %{_sysconfdir}/sysconfig/dhcpd
%config(noreplace) %{_sysconfdir}/sysconfig/dhcrelay
%config(noreplace) %{_sysconfdir}/dhcpd.conf
%{_initrddir}/dhcpd
%{_initrddir}/dhcrelay
%{_bindir}/omshell
%{_sbindir}/dhcpd
%{_sbindir}/dhcrelay
%attr(0644,root,root) %{_mandir}/man1/omshell.1.gz
%attr(0644,root,root) %{_mandir}/man5/dhcpd.conf.5.gz
%attr(0644,root,root) %{_mandir}/man5/dhcpd.leases.5.gz
%attr(0644,root,root) %{_mandir}/man8/dhcpd.8.gz
%attr(0644,root,root) %{_mandir}/man8/dhcrelay.8.gz
%attr(0644,root,root) %{_mandir}/man5/dhcp-options.5.gz
%attr(0644,root,root) %{_mandir}/man5/dhcp-eval.5.gz

%files -n dhclient
%defattr(-,root,root,-)
%doc dhclient.conf.sample
%dir %{_localstatedir}/lib/dhclient
/sbin/dhclient
/sbin/dhclient-script
%attr(0644,root,root) %{_mandir}/man5/dhclient.conf.5.gz
%attr(0644,root,root) %{_mandir}/man5/dhclient.leases.5.gz
%attr(0644,root,root) %{_mandir}/man8/dhclient.8.gz
%attr(0644,root,root) %{_mandir}/man8/dhclient-script.8.gz
%attr(0644,root,root) %{_mandir}/man5/dhcp-options.5.gz
%attr(0644,root,root) %{_mandir}/man5/dhcp-eval.5.gz

%files devel
%defattr(-,root,root,-)
%{_includedir}/dhcpctl.h
%{_includedir}/isc-dhcp
%{_includedir}/omapip
%attr(0644,root,root) %{_mandir}/man3/omshell.3.gz
%attr(0644,root,root) %{_mandir}/man3/dhcpctl.3.gz
%attr(0644,root,root) %{_mandir}/man3/omapi.3.gz

%files static
%defattr(-,root,root,-)
%{_libdir}/libdhcpctl.a
%{_libdir}/libomapi.a

%files -n libdhcp4client
%defattr(0755,root,root,0755)
%{_libdir}/libdhcp4client-%{version}.so.*

%files -n libdhcp4client-devel
%defattr(0644,root,root,0755)
%{_includedir}/dhcp4client
%{_libdir}/pkgconfig/libdhcp4client.pc
%{_libdir}/libdhcp4client.so

%files -n libdhcp4client-static
%defattr(0644,root,root,0755)
%{_libdir}/libdhcp4client.a

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Tue Oct 09 2007 Christian Metzen <metzench@ccux-linux.de> 3.0.6-1
- Version update
- dhclient addition, splitted packages inspired by fedora
* Fri Sep 22 2006 Christian Metzen <metzench@ccux-linux.de> 3.0.4-1
- Version update
* Sun Jan 22 2006 Stefan Gottwald <gotti@ccux-linux.de> 3.0.3-1
- Initial Release
